#!/usr/home/rptlab2/bin/python
import os, sys
HTTP_PDFOUT='/pdfout'
PDFOUT='../../pdfout'
def sysinfo():
	import sys, socket
	return (socket.getfqdn(),sys.version,sys.platform,sys.executable,sys.byteorder)

def formNames(pw):
	if pw!='17gnarls':
		raise ValueError('asaasasasasasa')
	from brochure import interviewDict
	from timetable import trackDict
	return {'interviews': interviewDict, 'tracks': trackDict()}

def makeBrochure(pw,tracks,interviews,genBy,genFor):
	if pw!='17gnarls':
		raise ValueError('asaasasasasasa')
	from brochure import makeDoc
	from rlextra.utils.cgisupport import TimeStamp
	ts = TimeStamp(pfx='-')
	_fn = 'brochure-'+ts.currentId+'.pdf'
	fn = os.path.join(PDFOUT,_fn)
	makeDoc(tracks=tracks,interviews=interviews,genBy=genBy,genFor=genFor,fn=fn)
	return {'filename':HTTP_PDFOUT+'/'+_fn,'filesize': int(os.stat(fn)[6])}

def makeTimetable(pw,pagesize):
	if pw!='17gnarls':
		raise ValueError('asaasasasasasa')
	from brochure import _init_TT
	from timetable import makeTT
	from rlextra.utils.cgisupport import TimeStamp
	ts = TimeStamp(pfx='-')
	_fn = 'timetable-'+ts.currentId+'.pdf'
	fn = os.path.join(PDFOUT,_fn)
	makeTT(_init_TT(),fn,pagesize)
	return {'filename':HTTP_PDFOUT+'/'+_fn,'filesize': int(os.stat(fn)[6])}

def run(http_pdfout='/pdfout',pdfout='../../pdfout'):
	global HTTP_PDFOUT,PDFOUT
	HTTPD_PDFOUT=http_pdfout
	PDFOUT=pdfout
	from rlextra.utils.SimpleXMLRPCServer import CGIXMLRPCRequestHandler
	server = CGIXMLRPCRequestHandler()
	server.register_function(sysinfo)
	server.register_function(formNames)
	server.register_function(makeBrochure)
	server.register_function(makeTimetable)

	server.handle_request()

if __name__=='__main__':
	run()
